
/* compiled in default charset */
extern unsigned char SOMFont_default_charset[];

/* load charset from smc */
char *SOMFontLoad( const char *filename );

/* for easier reading of source: free mem allocated for charset */
#define SOMFontUnload(x) gm_free(x)

/* initialize Console for use
   must be called before any other console function */
void SOMFontConsoleInit( GPDRAWSURFACE *gpDraw, const unsigned char *charset,
                         unsigned char fc, unsigned char bc );

/* set the charset for console output
   if charset is NULL the default font will be used */
void SOMFontConsoleCharset( const unsigned char *charset );

/* print out a message
   will only print out chars between 32 and 127, all other will be set to space
   '\n' will put cursor to the beginning of next line
   '\r' will put cursor to the beginning of actual line */
void SOMFontConsolePrint( const unsigned char *message );

/* clear screen and put cursor to top left corner */
void SOMFontConsoleClear( unsigned char bc );

/* set the color for output */
void SOMFontConsoleColor( unsigned char fc );

/* puts the cursor on specified position
   if x or y is < 0 if will not be changed */
void SOMFontConsoleCursor( short x, short y );

/* draw a character to position on screen */
void SOMFontDrawChar(GPDRAWSURFACE *ds, int x, int y, 
   const unsigned char *cs, unsigned char ch,
   unsigned char fc, unsigned char bc, unsigned char tc);

/* draw a string to position on screen */
void SOMFontDrawString(GPDRAWSURFACE *ds, int x, int y, 
   const unsigned char *cs, const unsigned char *string,
   unsigned char fc, unsigned char bc, unsigned char tc);

/* draw a string in an outlined font to position on screen
   note: this is done by drawing 5 characters instead of one, so it's 5 times slower
   x and y mark the position of the character, not the outline */
void SOMFontDrawOutlineString(GPDRAWSURFACE *ds, int x, int y, 
   const unsigned char *cs, const unsigned char *string,
   unsigned char fc, unsigned char oc);

/* fast draw by direct screenbuffer access in 32 bit words */
void SOMFontFastString(GPDRAWSURFACE *ds, int x, int y, 
   const unsigned char *cs, const unsigned char *string,
   unsigned char fc, unsigned char bc);

/* find a color that doesn't match fc or bc */
unsigned char SOMFontFindNonTransColor( unsigned char fc, unsigned char bg );
