
#include <gpstdio.h>
#include <gpgraphic.h>
#include <gpmem.h>
#include "intern.h"

extern GPDRAWSURFACE *GPDRAW;

char *SOMFontLoad( const char *filename )
{
   unsigned char  *buffer;
   F_HANDLE       fh   = 0;
   ERR_CODE       err  = 0;
   long           size = 0;
   long           read = 0;
   unsigned char  *b;
   
   err = GpFileGetSize( filename, &size );
   if( err != SM_OK ) return NULL;
   if( (size != 512) && (size != 768) && (size != 1792) )
      return NULL;
   
   err = GpFileOpen( filename, OPEN_R, &fh );
   if( err != SM_OK ) return NULL;
   
   buffer = (unsigned char*)gm_malloc(size);
   b = buffer;
   gm_memset( b, 0xff, size );
   
   while(read < size)
   {
      err = GpFileRead( fh, b, size-read, &read );
      if( err != SM_OK ) return NULL;
      b    += read;
   }
   
   GpFileClose( fh );
   
   /* write marking 2 for 512 bytes font (0x20-0x5f),
                    3 for 768 bytes font (0x20-0x7f),
                    7 for 1792 bytes font (0x20-0xff) */
   *buffer = (size >> 8) & 0xff;
   
   return buffer;
}
