
#include <global.h>
#include <gpvorbis.h>

int gpvorbis_open( const char *filename )
{
   F_HANDLE       fh;
   ERR_CODE       err;
   vorbis_comment *vc;
   vorbis_info    *vi;
   int            rv;

   err = GpFileOpen( filename, OPEN_R, &fh );
   if( err != SM_OK )
   {
      return -1;
   }
   
   rv = ov_open( (void*)fh, &vorbis_vf, NULL, 0 );
   if( rv < 0 )
   {
      return -2;
   }

   vc = ov_comment( &vorbis_vf, -1 );
   vi = ov_info( &vorbis_vf, -1 );
   
   vorbis_channels        = vi->channels;
   vorbis_rate            = vi->rate;
   vorbis_decoded_size    = (long)ov_time_total( &vorbis_vf, -1 );
   vorbis_user_comments   = vc->user_comments;
   vorbis_comment_lengths = vc->comment_lengths;
   vorbis_comments        = vc->comments;
   vorbis_vendor          = vc->vendor;
   
   /* change pcm rate here maybe some time */
   return 0;
}
