
#include <global.h>
#include <gpvorbis.h>

OggVorbis_File    vorbis_vf;
int               vorbis_channels;
int               vorbis_rate;
long              vorbis_decoded_size;
char              **vorbis_user_comments;
int               *vorbis_comment_lengths;
int               vorbis_comments;
char              *vorbis_vendor;


int vorbis_init()
{
   vorbis_channels          = 2;
   vorbis_rate              = 44100;
   vorbis_decoded_size      = 0;
   vorbis_user_comments     = NULL;
   vorbis_comment_lengths   = NULL;
   vorbis_comments          = 0;
   vorbis_vendor            = NULL;
   
   memset(&vorbis_vf, 0, sizeof(vorbis_vf));

   return 0;
}



int vorbis_scan( const char *filename, struct entry_t *entry )
{
   char **comments;
   char *p;
   int *lengths;
   int i,n;
   
   if(gpvorbis_open( filename ))
   {
      return 0;
   }
   
   entry->filename=strdup(filename);

   lengths=vorbis_comment_lengths;
   comments=vorbis_user_comments;
   for(i = 0; i < vorbis_comments; i++)
   {
      p = *comments;
      
      n = strlen(config_info_line1);
      if(!strncasecmp(p,config_info_line1, n))
      {
         p += n;
         entry->artist = (char*)strndup(p, (*lengths) - n);
      }
      
      n = strlen(config_info_line2);
      if(!strncasecmp(p,config_info_line2, n))
      {
         p += n;
         entry->title = (char*)strndup(p, (*lengths) - n);
      }
      
      lengths++;
      comments++;
   }
   
   /* now strip the "gp:\" from filename */
   p = entry->filename + 4;
   if(!entry->artist) entry->artist = strdup(p);
   if(!entry->title)  entry->title  = strdup(p);
   entry->size = vorbis_decoded_size;
   
   vorbis_close();
   
   return 1;
}


int vorbis_seek( int offset )
{
   ogg_int64_t newpos = ov_time_tell( &vorbis_vf ) + offset;
   
   if(newpos < 0) newpos = 0;
   if(newpos > vorbis_decoded_size) newpos = vorbis_decoded_size;
   
   ov_time_seek( &vorbis_vf, newpos );
   
   return 0;
}
